#pragma once

// 0x4000 === 16384(16K)
#define HUGESIZE    0x4000
// 0x1000 === 4096(4K)
#define BUFFSIZE    0x1000
// 0x400 === 1024(1K)
#define DOCSIZE		0x400
// 0x100 === 256
#define TEXTSIZE    0x100
#define HALFVALUE	0x18
#define HEXNUMBER   0x10
#define MINFILESIZE 4
#define MAXICONFILESIZZE    51262

#define WM_SHOWPICTURE (WM_APP + 1)
// bitmap or ... or icon
#define WM_IMAGETYPE (WM_APP + 2)
// j[ς
//#define WM_SETMENU (WM_APP + 4)

// BYTE: unsigned char
#define uchar unsigned char
// WORD: unsigned short int
#define uint unsigned int
#define ushort unsigned short
// DWORD: unsigned long
#define ulong unsigned long

#ifdef CONSOLE
#define SUCCESS 0
#define FAILER  1
#endif

#define CAST(TYPE, PARM) ((TYPE)(PARM))
#define SIZECHECK(SIZE) (0xc0000000 & (SIZE))

// 0xFF 0xFE: byte order mark of UTF-16
#define BOMCODE L'\xFEFF'
#define BOMSTR L"\xFEFF"
// type of bitmap
#define BITMAPID 0x4d42

#define BINARYTEXTSIZE 9
#define STATUSBARHEIGHT 18

#define ICONSIZE 128
#define COLORCOUNT 3
#define TRANSPARENCYRANGE 0x01

typedef union
{
    struct
	{
		ulong ulLow;
		ulong ulHigh;
	} strQuadWord;
	uchar auchQuadWordAry[2 * sizeof(DWORD)];
} QUADWORD;

#define ERRORSTATE       -1
#define ALLDLGHIDE       0x000
#define SCANNERDLGSHOW   0x010
#define CHANGEDLGSHOW    0x020
#define PICTUREDLGSHOW   0x040
#define LISTDLGSHOW      0x080
#define TRANSFORMDLGSHOW 0x100
#define SEQUENCEDLGSHOW  0x200
#define DIFFERENCEDLGSHOW  0x400

//typedef struct tagBITMAPINFO {
//@@BITMAPINFOHEADER bmiHeader;
//@@RGBQUAD bmiColors[1];
// } BITMAPINFO;

typedef enum
{
    ALLFILEMODE,
	ARCHIVEONLYMODE,
    ARCHIVEEXCLUSIVEMODE,
	FOLDERMODE
} SELECTIONMODE;

typedef enum
{
    NOOPTIONMODE,
	ATTRIBUTESMODE,
	FILESIZEMODE,
	BOTHOPTIONMODE
} OPTIONMODE;

typedef struct
{
	SELECTIONMODE enmSelectionMode;
	OPTIONMODE enmOptionMode;
} LISTSTR;

#define TABCNT4 4
#define TABCNT8 8

typedef enum
{
	DISPLAYMODE,
	SEARCHMODE,
	LISTMODE
} ISDISPLAYMODE;

typedef enum
{
	TWOLINEMODE,
	ONELINEMODE,
	EXCLUSIVEMODE
} ISCONTAINMODE;

typedef enum
{
    RIGHTROTATEMODE,
    UPENDROTATEMODE,
    LEFTROTATEMODE,
	CONVERTMODE
} ROTATEMODE;

typedef enum
{
    NOBLOCKMODE,
    READYBLOCKMODE,
    STARTBLOCKMODE,
    ENDBLOCKMODE,
} BLOCKMODE;

#define PENWIDTH 2
typedef struct
{
	HDC	hSrcDeviceContext;
	int nSrcPosX;
	int nSrcPosY;
	int nSrcWidth;
	int nSrcHeight;
	HDC hDstDeviceContext;
	int nDstPosX;
	int nDstPosY;
	int nDstWidth;
	int nDstHeight;
} BITCOPYSTR;

// https://learn.microsoft.com/ja-jp/windows/win32/api/gdiplustypes/ne-gdiplustypes-status
typedef enum {
	Ok = 0,
	GenericError = 1,
	InvalidParameter = 2,
	OutOfMemory = 3,
	ObjectBusy = 4,
	InsufficientBuffer = 5,
	NotImplemented = 6,
	Win32Error = 7,
	WrongState = 8,
	Aborted = 9,
	FileNotFound = 10,
	ValueOverflow = 11,
	AccessDenied = 12,
	UnknownImageFormat = 13,
	FontFamilyNotFound = 14,
	FontStyleNotFound = 15,
	NotTrueTypeFont = 16,
	UnsupportedGdiplusVersion = 17,
	GdiplusNotInitialized = 18,
	PropertyNotFound = 19,
	PropertyNotSupported = 20,
	ProfileNotFound = 21
}STATUS;

// \̂̃o[Ȃ
typedef struct tagICONDIR {
	WORD    idReserved;         //\ς݁iɂOj
	WORD    idType;             //\[X^Cv@ACRF1AJ[\FQ
	WORD    idCount;            //ACR̐
}ICONFILEHEADER;

typedef struct tagICONDIRENTRY {
	BYTE    bWidth;         //摜iPʁFsNZj
	BYTE    bHeight;        //摜iPʁFsNZj
	BYTE    bColorCount;    //摜̐FiQTUFȏ͂Oj
	BYTE    bReserved;	    //\ς݁iɂOj
	WORD    wPlanes;        //J[v[@@iJ[\AwzbgX|bgj
	WORD    wBitCount;      //sNZ̃rbg[xiJ[\AxzbgX|bgj
	DWORD   dwBytesInRes;   //sNZf[^̃oCg
	DWORD   dwImageOffset;  //t@C擪sNZf[^܂ł̃ItZbg
}ICONINFOHEADER, *ICONINFOHEADERARY;

/*
typedef struct tagBITMAPINFOHEADER {
  DWORD biSize;
  LONG  biWidth;
  LONG  biHeight;
  WORD  biPlanes;
  WORD  biBitCount;
  DWORD biCompression;
  DWORD biSizeImage;
  LONG  biXPelsPerMeter;
  LONG  biYPelsPerMeter;
  DWORD biClrUsed;
  DWORD biClrImportant;
} BITMAPINFOHEADER;
*/

typedef enum {
	BMPTYPE,
	JPEGTYPE,
	GIFTYPE,
	TIFFTYPE,
	PNGTYPE,
	ICONTYPE
} IMAGETYPE;

typedef enum
{
	ERASEBORDERTYPE,
	PICBORDERTYPE,
	ICONBORDERTYPE
} BORDERTYPE;

typedef enum
{
	SETMENU1,
	SETMENU2,
	SETMENU3
} SETMENU;
	
typedef enum
{
	POINTTYPE,
	RECTANGLETYPE,
	NOCHANGETYPE
} CHANGETYPE;
